#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################
## Special thanks to Babdu89 and GRUB devs.
## LIBRAIRIES FOR OS-UNINSTALLER AND BOOT REPAIR
## http://ubuntuforums.org/showthread.php?t=1615667

gui_init() {
######## Initialization of translations ######
set -a
source gettext.sh
set +a
export TEXTDOMAIN=boot-sav    # same .mo for boot-repair and os-uninstaller
export TEXTDOMAINDIR="/usr/share/locale"
. /usr/bin/gettext.sh

######## Preparation of the first pulsate #########
echo "SET@pulsatewindow.set_icon_from_file('''$APPNAME.png''')"
echo "SET@pulsatewindow.set_title('''$(eval_gettext "$CLEANNAME")''')"
echo "SET@_label0.set_text('''$(eval_gettext $'Scanning systems'). $(eval_gettext $'This may require several minutes...')''')"
beginning_of_pulsate
######## During first pulsate ########
. /usr/share/boot-sav/${APPNAME}-translations.sh	#Tranlations specific to the app
. /usr/share/boot-sav/bs-init.sh					#Librairies common to os-uninstaller, boot-repair, and clean-ubiquity
. /usr/share/boot-sav/gui-update.sh					#Update librairies common to os-uninstaller and boot-repair
. /usr/share/boot-sav/gui-tab-other.sh				#Glade librairies common to os-uninstaller and boot-repair
init_and_updateapp
. /usr/share/boot-sav/bs-common.sh					#Librairies common to os-uninstaller, boot-repair, and clean-ubiquity
. /usr/share/boot-sav/gui-scan.sh					#Scan librairies common to os-uninstaller and boot-repair
. /usr/share/boot-sav/gui-tab-main.sh				#Glade librairies common to os-uninstaller and boot-repair
. /usr/share/boot-sav/gui-tab-loca.sh				#Glade librairies common to os-uninstaller and boot-repair
. /usr/share/boot-sav/gui-tab-grub.sh				#Glade librairies common to os-uninstaller and boot-repair
. /usr/share/boot-sav/gui-tab-mbr.sh				#Glade librairies common to os-uninstaller and boot-repair
. /usr/share/boot-sav/gui-actions.sh				#Action librairies common to os-uninstaller and boot-repair
. /usr/share/boot-sav/${APPNAME}-actions.sh			#Action librairies specific to the app
. /usr/share/boot-sav/${APPNAME}-gui.sh				#GUI librairies specific to the app
}

######################################### Pulsate ###############################

beginning_of_pulsate() {
echo 'SET@pulsatewindow.show()'; while true; do echo 'SET@_progressbar1.pulse()'; sleep 0.15; done &
pid_pulse=$!
}

end_of_pulsate() {
kill ${pid_pulse}; echo 'SET@pulsatewindow.hide()'
}

