#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################
## Special thanks to Babdu89 and GRUB devs.
## LIBRAIRIES FOR OS-UNINSTALLER AND BOOT REPAIR
## http://ubuntuforums.org/showthread.php?t=1615667

########################## Initialization of logs #######################
init_and_updateapp() {
DISABLE_UPDATE_FROM_PPA=yes # =yes for Debian packaging, =no for Boot-Repair-Disk packaging
DISABLE_TEMPORARY_CHANGE_THE_SOURCESLIST_OF_A_BROKEN_OS=no  # =no for Debian packaging , =no for Boot-Repair-Disk packaging
initialization
log_preparation
G2S_VERSION=$($PACKVERSION glade2script )
echo "g2s version : $G2S_VERSION"
check_type_package_presence
if [[ "$choice" != "exit" ]];then
	first_translations
	check_internet_connection
	#check_app_updates
	if [[ "$choice" != "exit" ]];then
		propose_recommended_packages
		if [[ "$choice" != "exit" ]];then
			activate_lvm_if_needed
			if [[ "$choice" != "exit" ]];then
				activate_raid_if_needed
				echo "SET@_label0.set_text('''$(eval_gettext $'Scanning systems'). $(eval_gettext $'This may require several minutes...')''')"
			fi
		fi
		if [[ "$choice" = "exit" ]];then
			end_of_pulsate
			zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${No_change_have_been_performed_on_your_computer_See_you_soon}"
			echo 'EXIT@@'
		fi
	fi
fi
}

first_translations() {
Scanning_systems=$(eval_gettext $'Scanning systems')
Operation_aborted=$(eval_gettext $'Operation aborted')
do_you_want_to_update=$(eval_gettext $'Do you want to update the software?')
this_will_update_from_ppa=$(eval_gettext $'this will download and install last version from its PPA')
No_change_have_been_performed_on_your_computer_See_you_soon=$(eval_gettext $'No change have been performed on your computer. See you soon!')
No_OS_have_been_found_on_this_computer=$(eval_gettext $'No OS have been found on this computer.')
Please_use_in_live_session=$(eval_gettext $'Please use this software in a live-session (live-CD or live-USB).')
Please_use_in_a_64bits_session=$(eval_gettext $'Please use this software in a 64bits session.')
CaixaMagica_installed_in_Windows_via_Wubi=$(eval_gettext $'Caixa Magica installed in Windows (via Wubi)')
No_internet_connection_detected=$(eval_gettext $'No internet connection detected')
The_software_could_not_be_updated=$(eval_gettext $'The software could not be updated.')
Please_close_all_your_package_managers=$(eval_gettext $'Please close all your package managers')
Software_Centre=$(eval_gettext $'Software Center')
Update_Manager=$(eval_gettext $'Update Manager')
Do_you_want_to_continue=$(eval_gettext $'Do you want to continue?')
Then_try_again=$(eval_gettext $'Then try again.')
Please_connect_internet=$(eval_gettext $'Please connect internet.')
Then_close_this_window=$(eval_gettext $'Then close this window.')
assemble_mdraid_arrays=$(eval_gettext $'Do you want to assemble software raid (MDRaid) arrays?')
activate_dmraid=$(eval_gettext $'Do you want to activate [dmraid] (fakeraid)?')
Please_check_options=$(eval_gettext $'Please check the options.')
There_may_be_newer_version=$(eval_gettext $'A new version of this software is available, please check its official website.')
#/// TRANSLATORS: Please do not translate [dmraid] and MDraid
dmraid_may_interfer_MDraid_remove=$(eval_gettext $'[dmraid] packages may interfer with MDraid. Do you want to remove them?')
#/// TRANSLATORS: Please do not translate Boot-Repair-Disk
Alternatively_you_can_use=$(eval_gettext $'Alternatively, you can use Boot-Repair-Disk which contains last version of this software.')
GRUB_reinstallation_has_been_cancelled=$(eval_gettext $'GRUB reinstallation has been cancelled.')
is_now_without_GRUB=$(eval_gettext $'is now without GRUB.')
This_will_install_an_obsolete_bootloader=$(eval_gettext $'This will install an obsolete bootloader')
Please_wait=$(eval_gettext $'Please wait few seconds...')
#/// TRANSLATORS: this string must be as short as possible
The_system_now_in_use=$(eval_gettext $'The OS now in use')
Advanced_options=$(eval_gettext $'Advanced options')
Main_options=$(eval_gettext $'Main options')
GRUB_location=$(eval_gettext $'GRUB location')
GRUB_options=$(eval_gettext $'GRUB options')
MBR_options=$(eval_gettext $'MBR options')
Other_options=$(eval_gettext $'Other options')
Reinstall_GRUB=$(eval_gettext $'Reinstall GRUB')
Restore_MBR=$(eval_gettext $'Restore MBR')
Unhide_boot_menu=$(eval_gettext $'Unhide boot menu')
seconds=$(eval_gettext $'seconds')
Restore_the_MBR_of=$(eval_gettext $'Restore the MBR of:')
Partition_booted_by_the_MBR=$(eval_gettext $'Partition booted by the MBR:')
OS_to_boot_by_default=$(eval_gettext $'OS to boot by default:')
Purge_and_reinstall_the_grub_of=$(eval_gettext $'Purge and reinstall the GRUB of:')
#/// TRANSLATORS: Please do not translate /boot
Separate_boot_partition=$(eval_gettext $'Separate /boot partition:')
#/// TRANSLATORS: Please do not translate /boot/efi
EFI_partition=$(eval_gettext $'Separate /boot/efi partition:')
Place_GRUB_in_all_disks=$(eval_gettext $'Place GRUB in all disks')
except_USB_disks_without_OS=$(eval_gettext $'except USB disks without OS')
is_a_removable_disk=$(eval_gettext $'is a removable disk.')
Place_GRUB_into=$(eval_gettext $'Place GRUB into:')
Force_GRUB_into=$(eval_gettext $'Force GRUB into:')
for_chainloader=$(eval_gettext $'for chainloader')
Use_last_grub=$(eval_gettext $'Upgrade GRUB to its most recent version')
RECENTREP="CaixaMagica-18"
#/// TRANSLATORS: Please do not translate ${RECENTREP}
Warning_lastgrub=$(eval_gettext $'Warning: this will install necessary packages from ${RECENTREP} repositories.')
Blank_extra_space=$(eval_gettext $'Reset extra space after MBR')
Warning_blankextra=$(eval_gettext $'Warning: some applications using DRM or some OEM system tools may not work afterwards.')
#/// TRANSLATORS: Please do not translate GRUB_GFXMODE
Uncomment_GRUB_GFXMODE=$(eval_gettext $'Uncomment GRUB_GFXMODE')
Ata_disk=$(eval_gettext $'ATA disk support')
Add_a_kernel_option=$(eval_gettext $'Add a kernel option:')
Edit_GRUB_configuration_file=$(eval_gettext $'Edit GRUB configuration file')
Applying_changes=$(eval_gettext $'Applying changes.')
This_may_require_several_minutes=$(eval_gettext $'This may require several minutes...')
This_will_enable_this_feature=$(eval_gettext $'This will enable this feature.')
Checking_updates=$(eval_gettext $'Checking updates')
Updating=$(eval_gettext $'Updating')
Translate=$(eval_gettext $'Translate')
Thanks=$(eval_gettext $'Credits')
Backup_table=$(eval_gettext $'Backup partition tables, bootsectors and logs')
Participate_stats=$(eval_gettext $'Participate to statistics of use')
Please_choose_folder_to_put_backup=$(eval_gettext $'Please choose a folder to put the backup into.')
USB_disk_recommended=$(eval_gettext $'It is recommended to choose a USB disk.')
Please_create_a_efi_partition=$(eval_gettext $'Please create a EFI partition.')
start_of_the_disk=$(eval_gettext $'start of the disk')
#/// TRANSLATORS: Please use lower-case letters for "flag" (not "Flag")
EFI_flag=$(eval_gettext $'EFI flag')
#/// TRANSLATORS: Please do not translate BootInfo
Create_a_BootInfo_report=$(eval_gettext $'Create a BootInfo summary')
to_get_help_by_email_or_forum=$(eval_gettext $'to get help by email or forum')
requires_internet=$(eval_gettext $'requires internet')
Please_note_the_following_url=$(eval_gettext $'Please note the following URL:')
Indicate_it_in_case_still_pb=$(eval_gettext $'In case you still experience boot problem, indicate this URL to:')
Indicate_its_content_in_case_still_pb=$(eval_gettext $'In case you still experience boot problem, indicate its content to:')
or_to_your_favorite_support_forum=$(eval_gettext $'or to your favorite support forum.')
Please_open_a_terminal_then_type_the_following_command=$(eval_gettext $'Please open a terminal then type (or copy-paste) the following command:')
Then_choose_Yes_when_the_below_window_appears=$(eval_gettext $'Then when a window similar to the one below appear in your terminal, use Tab and Enter keys in order to confirm GRUB removal.')
Now_please_type_this_command_in_the_terminal=$(eval_gettext $'Now please type (or copy-paste) the following command in a terminal:')
Then_select_correct_device_when_the_below_window_appears=$(eval_gettext $'Then when menus similar to the one below appear in your terminal, use Tab, Space and Enter keys in order to install GRUB in the disk you wish.')
GRUB_is_still_present=$(eval_gettext $'GRUB is still present.')
GRUB_is_still_absent=$(eval_gettext $'GRUB is still absent.')
Please_try_again=$(eval_gettext $'Please try again.')
Place_bootflag=$(eval_gettext $'Place the boot flag on:')

[[ "$APPNAME" = "boot-repair" ]] &&	first_translations_br || first_translations_os
update_translations
}

update_translations() {
#/// TRANSLATORS: Please do not translate FUNCTION. Neutral and singular.
FUNCTION_detected=$(eval_gettext $'${FUNCTION} detected.')
#/// TRANSLATORS: Please do not translate [${PACKAGELIST}]
This_will_install_PACKAGELIST=$(eval_gettext $'This will install the [${PACKAGELIST}] packages.')
#/// TRANSLATORS: Please do not translate [${PACKAGELIST}]
Do_you_want_to_install_PACKAGELIST=$(eval_gettext $'Do you want to install the [${PACKAGELIST}] packages?')
#/// TRANSLATORS: Please do not translate [${PACKAGELIST}]
please_install_PACKAGELIST=$(eval_gettext $'Please install the [${PACKAGELIST}] packages.')
#/// TRANSLATORS: Please do not translate [${NEEDEDREP}]
This_may_require_to_enable_NEEDEDREP=$(eval_gettext $'This may require to enable [${NEEDEDREP}] repositories.')
#/// TRANSLATORS: Please do not translate ${FILE}
logs_have_been_saved_into_FILE=$(eval_gettext $'Partition tables, MBRs and logs have been saved into ${FILE}')
#/// TRANSLATORS: Please do not translate [${PACKAGELIST}] nor ${DISTRO}
Please_enable_a_rep_for_PACKAGELIST_pack_in_DISTRO=$(eval_gettext $'Please enable a repository containing the [${PACKAGELIST}] packages in the software sources of ${DISTRO}.')
#/// TRANSLATORS: Please do not translate [${BUG}]
solves_BUG=$(eval_gettext $'solves the [${BUG}] error')
#/// TRANSLATORS: Please do not translate ${FUNCTION}
Enabling_FUNCTION=$(eval_gettext $'Enabling ${FUNCTION}')
#/// TRANSLATORS: Please do not translate ${MODE1} nor ${MODE2}
Boot_is_MODE1_change_to_MODE2=$(eval_gettext $'The boot of your PC is in ${MODE1} mode. Please change it to ${MODE2} mode.')
#/// TRANSLATORS: Please do not translate ${MODE1} nor ${MODE2}
Boot_is_MODE1_change_but_no_MODE2_part_detected=$(eval_gettext $'The boot of your PC is in ${MODE1} mode, but no ${MODE2} partition was detected.')
#/// TRANSLATORS: Please do not translate ${TYP}
You_may_want_to_retry_after_creating_TYP_part=$(eval_gettext $'You may want to retry after creating a ${TYP} partition')
#/// TRANSLATORS: Please do not translate ${FILENAME}
FILENAME_has_been_created=$(eval_gettext $'A new file (${FILENAME}) will open in your text viewer.')

[[ "$APPNAME" = "boot-repair" ]] &&	update_translations_br || update_translations_os
}

########################################### CHECK INTERNET CONNECTION ############################################
check_internet_connection() {
[[ "$(wget -q -O - checkip.dyndns.org)" =~ "Current IP Address:" ]] && INTERNET=connected || INTERNET=no-internet
echo "internet: $INTERNET"
}


########################################### CHECK APP UPDATE ############################################
check_app_updates() {
if [[ -f /var/log/${PACK_NAME}/reboot ]] || [[ -f /tmp/clean_reboot ]];then
	rm /tmp/clean_reboot
	rm /var/log/${PACK_NAME}/reboot #After update
else
	UPPDATE="/var/log/${PACK_NAME}/update${APPNAME}$(date +'%Y-%m-%d_%H')"
	if [[ ! -f ${UPPDATE} ]]; then	# No update during 1~59 minutes
		end_of_pulsate
		if [[ "$DISABLE_UPDATE_FROM_PPA" = "no" ]] && [[ "$(type -p apt-get)" ]];then
			propose_updateapp
		else
			zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${There_may_be_newer_version} ${Alternatively_you_can_use}"
			beginning_of_pulsate
		fi
	fi
fi
}

propose_updateapp() {
zenity --question --title="$(eval_gettext "$CLEANNAME")" --text="${do_you_want_to_update} (${this_will_update_from_ppa})" || choice="noupdate"
beginning_of_pulsate
if [[ "$choice" != "noupdate" ]];then
	ask_internet_connection
	if [[ "$INTERNET" = "connected" ]];then
		echo "SET@_label0.set_text('''$(eval_gettext $'Checking updates'). $(eval_gettext $'This may require several minutes...')''')"
		PSP_VERSION="0.60" #default (also Debian stable version)
		INSPACK=""
		for temp in boot-repair os-uninstaller;do
			hash ${temp} && INSPACK="${temp} $INSPACK"
		done
		hash cleanubiquitybefore && INSPACK="$INSPACK clean-ubiquity"
		for APPROLL in $INSPACK;do #to avoid breaking v <3.03
			if hash apt-add-repository;then
				temp=$(LANGUAGE=C LC_ALL=C $PACKPOLICY python-software-properties | grep Installed );
				PSP_VERSION=${temp#* Installed: };echo "python-software-properties version : $PSP_VERSION"
				if [[ "$(grep "0.7[5-9]" <<< "$PSP_VERSION" )" ]] || [[ "$(grep "0.[8-9][0-9]" <<< "$PSP_VERSION" )" ]];then
					if [[ "$(grep "0.7[5-9]" <<< "$PSP_VERSION" )" ]] || [[ "$PSP_VERSION" =~ 0.80 ]];then
						add-apt-repository ppa:yannubuntu/${APPROLL}
					else
						add-apt-repository -y ppa:yannubuntu/${APPROLL}
					fi
				fi
			elif [[ -f "/etc/apt/sources.list" ]];then #and PSP < 0.75
				for vvv in lucid oneiric finisterra;do	#to avoid python dep error
					PPADEB="deb http://ppa.launchpad.net/yannubuntu/${APPROLL}/ubuntu ${vvv} main"
					if [[ ! "$(cat /etc/apt/sources.list | grep "${PPADEB}" | grep -v "#deb" | grep -v "# deb" )" ]];then
						cp /etc/apt/sources.list $LOGREP/sources.list
						echo "${PPADEB}" >> /etc/apt/sources.list
					fi
				done
			else
				echo "Warning: no /etc/apt/sources.list"
			fi
		done
		loop_updateapp
		
		if [[ "$choice" = "exit" ]];then
			echo 'EXIT@@'
		elif [[ "$choice" != "noupdate" ]];then
			touch ${UPPDATE}	# To avoid useless update next time the tool is used
			APPNAME_NEW=$($PACKVERSION $APPNAME )
			COMMON_NEW=$($PACKVERSION boot-sav )
			if [[ "$APPNAME_NEW" != "$APPNAME_VERSION" ]] || [[ "$COMMON_NEW" != "$COMMON_VERSION" ]];then
				echo "${APPNAME} has been updated"
				end_of_pulsate
				touch /var/log/${PACK_NAME}/reboot
				choice="exit"; echo 'EXIT@@'
			fi
		fi
	else
		end_of_pulsate
		zenity --warning --timeout=3 --title="$(eval_gettext "$CLEANNAME")" --text="${No_internet_connection_detected}. ${The_software_could_not_be_updated}"
		beginning_of_pulsate
	fi
fi
}

loop_updateapp() {
echo "SET@_label0.set_text('''$(eval_gettext $'Updating'). $(eval_gettext $'This may require several minutes...')''')"
temp=$($PACKMAN $PACKYES update)
DEBCHECK="debOK"
if [[ "$PACKMAN" = "apt-get" ]];then
	for DEBTOCHECK in boot-sav glade2script $INSPACK;do # $INSPACK at the end
		rm -f /var/cache/apt/archives/${DEBTOCHECK}_*
		$PACKMAN -d $PACKYES install --reinstall $DEBTOCHECK && DEBCHECK="debOK" || DEBCHECK="debNG" #internet KO or dpkg blocked (e.g. Synaptic is open)
	done
fi
if [[ "$DEBCHECK" != "debNG" ]];then
	for p in $INSPACK boot-sav boot-sav-gui clean clean-gui clean-ubiquity-common boot-repair-common;do
		temp=$($PACKMAN $PACKPURGE $PACKYES )
	done
	temp=$($PACKMAN install $PACKYES $INSPACK)
	[[ "$PACKMAN" = "apt-get" ]] && temp=$($PACKMAN -f $PACKYES install)
else
	end_of_pulsate
	zenity --warning --title="$(eval_gettext "$CLEANNAME")" --text="${Please_close_all_your_package_managers} (${Software_Centre}, ${Update_Manager}, Synaptic, ...). ${Then_try_again}"
	echo "$PACKMAN blocked"
	choice="exit"
fi
}


########################################### INSTALL NEEDED PACKAGES ############################################
check_type_package_presence() {
if [[ ! "$(type -p bash)" ]];then
	PACKAGELIST=type
	end_of_pulsate
	zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${please_install_PACKAGELIST} ${Then_try_again}"
	exit_as_packagelist_is_missing
fi
}

propose_recommended_packages() {
PACKAGELIST=""
FILETOTEST=""
for paka in parted os-prober syslinux;do
	if [[ ! "$(type -p $paka)" ]];then
		PACKAGELIST="$paka $PACKAGELIST"
		FILETOTEST="$paka $FILETOTEST"
	fi
done
if [[ "$PACKAGELIST" ]];then
	FUNCTION="Parted&os-prober"
	installpackagelist
fi
if [[ ! "$(type -p os-prober)" ]];then
	PACKAGELIST=os-prober
	exit_as_packagelist_is_missing
fi
}

exit_as_packagelist_is_missing() {
update_translations
echo "$please_install_PACKAGELIST"
choice="exit"; echo 'EXIT@@'
}

activate_lvm_if_needed() {
BLKID=$(blkid)
if [[ "$BLKID" =~ LVM ]];then
	FUNCTION="LVM"
	PACKAGELIST="lvm2"
	FILETOTEST="vgchange"
	installpackagelist
	if [[ ! "$(type -p $FILETOTEST)" ]];then
		choice="exit"
	else
		echo "LVBKID $BLKID"
		echo "MODPROBE"
		modprobe dm-mod		# Not sure it is necessary
		echo "VGSCAN"
		vgscan --mknodes	# Not sure it is necessary
		echo "VGCHANGE"
		vgchange -ay		# Activate volumes
		LVSCAN="$(LANGUAGE=C LC_ALL=C lvscan)"
		echo "LVSCAN: $LVSCAN"
		[[ "$LVSCAN" =~ inactive ]] && echo "Warning: inactive LVM"
	fi
fi
}

activate_raid_if_needed() {
if [[ "$BLKID" =~ raid ]] || [[ "$BLKID" =~ "/dev/mapper/" ]];then
	FUNCTION="RAID"
	PACKAGELIST="mdadm --no-install-recommends"
	FILETOTEST="mdadm"
	echo "RAIDBKID $BLKID"
	installpackagelist
	mdadmenable=""
	dmraidenable=""
	if [[ "$(type -p mdadm)" ]];then
		removedmraid="yes"
		if [[ "$(type -p dmraid)" ]];then	#http://ubuntuforums.org/showthread.php?t=1551087
			end_of_pulsate
			zenity --question --title="$(eval_gettext "$CLEANNAME")" --text="${dmraid_may_interfer_MDraid_remove}" || removedmraid="no"
			beginning_of_pulsate
			[[ "$removedmraid" = "yes" ]] && $PACKMAN remove $PACKYES dmraid
		fi
		end_of_pulsate
		zenity --question --title="$(eval_gettext "$CLEANNAME")" --text="${FUNCTION_detected} ${assemble_mdraid_arrays} (mdadm --assemble --scan)" || mdadmenable="no"
		beginning_of_pulsate
		if [[ ! "$mdadmenable" ]]; then
			echo "Scanning MDraid Partitions"
			mdadm --assemble --scan 	# Assemble all arrays
			# All arrays.
			MD_ARRAY=$(mdadm --detail --scan) #TODO  | ${AWK} '{ print $2 }')
			echo "MD_ARRAY $MD_ARRAY"
			#for MD in ${MD_ARRAY}; do
			#	MD_SIZE=$(fdisks ${MD})     # size in blocks
			#	MD_SIZE=$((2*${MD_SIZE}))   # size in sectors
			#	MDNAME=${MD:5}
			#	MDMOUNTNAME="MDRaid/${name}"
			#	echo "MD${MD}: ${MDNAME}, ${MDMOUNTNAME}, ${MD_SIZE}"
			#done
		fi
	fi
	if [[ ! "$(type -p mdadm)" ]] && [[ ! "$(type -p dmraid)" ]];then
		PACKAGELIST="dmraid"
		FILETOTEST="dmraid"
		installpackagelist
		[[ ! "$(type -p dmraid)" ]] && [[ "$useroktoinstall" ]] && choice="exit"
	fi
	if [[ "$(type -p dmraid)" ]] && [[ "$choice" != "exit" ]];then
		end_of_pulsate
		zenity --question --title="$(eval_gettext "$CLEANNAME")" --text="${FUNCTION_detected} ${activate_dmraid} (dmraid -ay; dmraid -sa -c)" || dmraidenable="no"
		beginning_of_pulsate
		if [[ ! "$dmraidenable" ]]; then
			DMRAID="$(dmraid -si -c)"
 			if [[ "$DMRAID" = "no raid disks" ]];then
				DMRAID=""
				echo "No RAID disk"
 			else
				dmraid -ay	#Activate RAID
				DMRAID="$(dmraid -sa -c)"
				echo "DMRAID $DMRAID"	#e.g. isw_bcbggbcebj_ARRAY
			fi
		fi
	fi
	echo "[debug]$(type -p dmraid) , MDADM $(type -p mdadm), $mdadmenable , $dmraidenable ; $choice"
	[[ ! "$(type -p dmraid)" ]] && [[ ! "$(type -p mdadm)" ]] || [[ "$mdadmenable" ]] || [[ "$dmraidenable" ]] && choice="exit"
fi
}

ask_internet_connection() {
if [[ "$INTERNET" != "connected" ]];then
	end_of_pulsate
	zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${Please_connect_internet} ${Then_close_this_window}"
	beginning_of_pulsate
	check_internet_connection
fi
}
